package org.jeecg.modules.workOrder.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.regular.entity.RegularInput;
import org.jeecg.modules.regular.mapper.RegularInputMapper;
import org.jeecg.modules.workOrder.entity.WorkRecord;
import org.jeecg.modules.workOrder.service.IWorkRecordService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 作业数据记录
 * @Author: jeecg-boot
 * @Date:   2025-02-20
 * @Version: V1.0
 */
@Api(tags="作业数据记录")
@RestController
@RequestMapping("/workOrder/workRecord")
@Slf4j
public class WorkRecordController extends JeecgController<WorkRecord, IWorkRecordService> {
	@Autowired
	private IWorkRecordService workRecordService;
	 @Autowired
	 private RegularInputMapper regularInputMapper;

	/**
	 * 分页列表查询
	 *
	 * @param workRecord
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "作业数据记录-分页列表查询")
	@ApiOperation(value="作业数据记录-分页列表查询", notes="作业数据记录-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<WorkRecord>> queryPageList(WorkRecord workRecord,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WorkRecord> queryWrapper = QueryGenerator.initQueryWrapper(workRecord, req.getParameterMap());
		Page<WorkRecord> page = new Page<WorkRecord>(pageNo, pageSize);
		IPage<WorkRecord> recordIPage = workRecordService.queryPages(page, queryWrapper);
		recordIPage.getRecords().forEach(record->{
			RegularInput input = regularInputMapper.selectById(record.getRegularInputId());
			record.setMaxValue(input.getMaxValue());
			record.setMinValue(input.getMinValue());
			if(record.getNumericValue()!=null) {
				// 判断结果是否合格
				double value = Double.parseDouble(record.getNumericValue());
				Double min = input.getMinValue();
				Double max = input.getMaxValue();
				record.setResultOverGauge((min == null || value >= min) && (max == null || value <= max));
			}
		});
		return Result.OK(recordIPage);
	}

	 @ApiOperation(value="作业数据记录-列表查询", notes="作业数据记录-列表查询")
	 @GetMapping(value = "/list/nopage")
	 public Result<List<WorkRecord>> queryList(WorkRecord workRecord,HttpServletRequest req) {
		 QueryWrapper<WorkRecord> queryWrapper = QueryGenerator.initQueryWrapper(workRecord, req.getParameterMap());
		 List<WorkRecord> records = workRecordService.list(queryWrapper);
		 records.forEach(record->{
			 RegularInput input = regularInputMapper.selectById(record.getRegularInputId());
			 record.setMaxValue(input.getMaxValue());
			 record.setMinValue(input.getMinValue());
			 if(record.getNumericValue()!=null) {
				 // 判断结果是否合格
				 double value = Double.parseDouble(record.getNumericValue());
				 Double min = input.getMinValue();
				 Double max = input.getMaxValue();
				 record.setResultOverGauge((min == null || value >= min) && (max == null || value <= max));
			 }
		 });
		 return Result.OK(records);
	 }

	/**
	 *   添加
	 *
	 * @param workRecord
	 * @return
	 */
	@AutoLog(value = "作业数据记录-添加")
	@ApiOperation(value="作业数据记录-添加", notes="作业数据记录-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_work_record:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WorkRecord workRecord) {
		workRecordService.save(workRecord);
		return Result.OK("添加成功！");
	}

	 /**
	  *   逐条添加
	  *
	  * @param data
	  * @return
	  */
	 @AutoLog(value = "作业数据记录-逐条添加")
	 @ApiOperation(value="作业数据记录-逐条添加", notes="作业数据记录-逐条添加")
	 //@RequiresPermissions("org.jeecg.modules:bu_work_record:add")
	 @PostMapping(value = "/insert")
	 public Result<String> insert(@RequestBody Map<String, Object> data) {
		  workRecordService.insertWorkRecord(data);
		 return Result.OK("添加成功！");
	 }
	/**
	 *  编辑
	 *
	 * @param workRecord
	 * @return
	 */
	@AutoLog(value = "作业数据记录-编辑")
	@ApiOperation(value="作业数据记录-编辑", notes="作业数据记录-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_work_record:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WorkRecord workRecord) {
		workRecordService.updateById(workRecord);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "作业数据记录-通过id删除")
	@ApiOperation(value="作业数据记录-通过id删除", notes="作业数据记录-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_work_record:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		workRecordService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "作业数据记录-批量删除")
	@ApiOperation(value="作业数据记录-批量删除", notes="作业数据记录-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_work_record:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.workRecordService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "作业数据记录-通过id查询")
	@ApiOperation(value="作业数据记录-通过id查询", notes="作业数据记录-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<WorkRecord> queryById(@RequestParam(name="id",required=true) String id) {
		WorkRecord workRecord = workRecordService.getById(id);
		if(workRecord==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(workRecord);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param workRecord
    */
    //@RequiresPermissions("org.jeecg.modules:bu_work_record:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WorkRecord workRecord) {
        return super.exportXls(request, workRecord, WorkRecord.class, "作业数据记录");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_work_record:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WorkRecord.class);
    }

}
